Index: branches/1.3/gui/scripts/vtkheightmapviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkheightmapviewer.tcl	(revision 4828)
+++ branches/1.3/gui/scripts/vtkheightmapviewer.tcl	(revision 4848)
@@ -7,5 +7,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2014  HUBzero Foundation, LLC
+#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 #
 #  See the file "license.terms" for information on usage and
@@ -58,4 +58,5 @@
     public method get {args}
     public method isconnected {}
+    public method limits3 { dataobj }
     public method parameters {title args} { 
         # do nothing 
@@ -63,6 +64,23 @@
     public method scale {args}
 
+    protected method CameraReset {}
+    protected method Connect {}
+    protected method CurrentDatasets {args}
+    protected method Disconnect {}
+    protected method DoResize {}
+    protected method DoRotate {}
+    protected method AdjustSetting {what {value ""}}
+    protected method AdjustMode {}
+    protected method InitSettings { args  }
+    protected method Pan {option x y}
+    protected method Pick {x y}
+    protected method Rebuild {}
+    protected method ReceiveDataset { args }
+    protected method ReceiveImage { args }
+    protected method ReceiveLegend { colormap title min max size }
+    protected method Rotate {option x y}
+    protected method Zoom {option}
+
     # The following methods are only used by this class.
-    private method AdjustSetting {what {value ""}}
     private method BuildAxisTab {}
     private method BuildCameraTab {}
@@ -70,45 +88,24 @@
     private method BuildContourTab {}
     private method BuildDownloadPopup { widget command } 
-    private method CameraReset {}
     private method Combo { option }
-    private method Connect {}
-    private method CurrentDatasets {args}
-    private method Disconnect {}
-    private method DoResize {}
-    private method DoRotate {}
     private method DrawLegend {}
     private method EnterLegend { x y } 
     private method EventuallyRequestLegend {} 
     private method EventuallyResize { w h } 
-    private method EventuallyRotate { q }
-    private method GetHeightmapScale {} 
+    private method EventuallyRotate { q } 
     private method GetImage { args } 
     private method GetVtkData { args } 
-    private method InitSettings { args  }
     private method IsValidObject { dataobj } 
     private method LeaveLegend {}
     private method MotionLegend { x y } 
-    private method Pan {option x y}
     private method PanCamera {}
-    private method Pick {x y}
-    private method QuaternionToView { q } { 
-        foreach { _view(-qw) _view(-qx) _view(-qy) _view(-qz) } $q break
-    }
-    private method Rebuild {}
-    private method ReceiveDataset { args }
-    private method ReceiveImage { args }
-    private method ReceiveLegend { colormap title min max size }
     private method RequestLegend {}
-    private method ResetAxes {}
-    private method Rotate {option x y}
     private method SetCurrentColormap { color }
     private method SetLegendTip { x y }
     private method SetObjectStyle { dataobj comp } 
+    private method GetHeightmapScale {} 
+    private method ResetAxes {}
     private method SetOrientation { side }
     private method UpdateContourList {}
-    private method ViewToQuaternion {} { 
-        return [list $_view(-qw) $_view(-qx) $_view(-qy) $_view(-qz)]
-    }
-    private method Zoom {option}
 
     private variable _arcball ""
@@ -126,4 +123,5 @@
     private variable _currentColormap ""
     private variable _currentNumIsolines -1
+    private variable _currentOpacity ""
 
     private variable _maxScale 100;     # This is the # of times the x-axis
@@ -205,48 +203,48 @@
     # Initialize the view to some default parameters.
     array set _view {
-        -ortho           0
-        -qw              0.36
-        -qx              0.25
-        -qy              0.50
-        -qz              0.70
-        -xpan            0
-        -ypan            0
-        -zoom            1.0
+        qw	0.36
+        qx	0.25
+        qy	0.50
+        qz	0.70
+        zoom	1.0 
+        xpan	0
+        ypan	0
+        ortho	0
     }
     set _arcball [blt::arcball create 100 100]
-    $_arcball quaternion [ViewToQuaternion]
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    $_arcball quaternion $q
 
     array set _settings {
-        -axisflymode            "static"
-        -axislabels             1
-        -axisminorticks         1
-        -axisvisible            1
-        -colormap               BCGYR
-        -colormapdiscrete       0
-        -colormapvisible        1
-        -edges                  0
-        -field                  "Default"
-        -heightmapscale         50
-        -isheightmap            0
-        -isolinecolor           black
-        -isolinesvisible        1
-        -legendvisible          1
-        -lighting               1
-        -numisolines            10
-        -opacity                100
-        -outline                0
-        -savelighting           1
-        -saveopacity            100
-        -saveoutline            0
-        -stretchtofit           0
-        -wireframe              0
-        -xgrid                  0
-        -ygrid                  0
-        -zgrid                  0
+        axisFlymode		"static"
+        axisMinorTicks		1
+        stretchToFit		0
+        axisLabels              1
+        axisVisible		1
+        axisXGrid		0
+        axisYGrid		0
+        axisZGrid		0
+        colormapVisible         1
+        colormapDiscrete        0
+        edges			0
+        field			"Default"
+        heightmapScale		50
+        isHeightmap		0
+        isolineColor            black
+        isolinesVisible         1
+        legendVisible           1
+        lighting		1
+        saveLighting		1
+        numIsolines		10
+        opacity                 100
+        outline			0
+        wireframe		0
+        saveOpacity		100
+        saveOutline		0
     }
     array set _changed {
-        -colormap               0
-        -numisolines            0
-        -opacity                0
+        opacity                 0
+        colormap                0
+        numIsolines             0
     }
     itk_component add view {
@@ -327,6 +325,6 @@
             -onimage [Rappture::icon surface] \
             -offimage [Rappture::icon surface] \
-            -variable [itcl::scope _settings(-isheightmap)] \
-            -command [itcl::code $this AdjustSetting -isheightmap] \
+            -variable [itcl::scope _settings(isHeightmap)] \
+            -command [itcl::code $this AdjustSetting isHeightmap] \
     }
     Rappture::Tooltip::for $itk_component(mode) \
@@ -338,6 +336,6 @@
             -onimage [Rappture::icon stretchtofit] \
             -offimage [Rappture::icon stretchtofit] \
-            -variable [itcl::scope _settings(-stretchtofit)] \
-            -command [itcl::code $this AdjustSetting -stretchtofit] \
+            -variable [itcl::scope _settings(stretchToFit)] \
+            -command [itcl::code $this AdjustSetting stretchToFit] \
     }
     Rappture::Tooltip::for $itk_component(stretchtofit) \
@@ -444,5 +442,6 @@
 
 itcl::body Rappture::VtkHeightmapViewer::DoRotate {} {
-    SendCmd "camera orient [ViewToQuaternion]" 
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    SendCmd "camera orient $q" 
     set _rotatePending 0
 }
@@ -468,5 +467,5 @@
 
 itcl::body Rappture::VtkHeightmapViewer::EventuallyRotate { q } {
-    QuaternionToView $q
+    foreach { _view(qw) _view(qx) _view(qy) _view(qz) } $q break
     if { !$_rotatePending } {
         set _rotatePending 1
@@ -667,5 +666,5 @@
     }
     if { [array size found] > 1 } {
-        set _settings(-stretchtofit) 1
+        set _settings(stretchToFit) 1
     } else {
         # Check if the range of the x and y axes requires that we stretch
@@ -676,5 +675,5 @@
         if { (($xmax - $xmin) > (($ymax -$ymin) * $_maxScale)) ||
              ((($xmax - $xmin) * $_maxScale) < ($ymax -$ymin)) } {
-            set _settings(-stretchtofit) 1
+            set _settings(stretchToFit) 1
         }
     }
@@ -843,7 +842,6 @@
     if { $info(-type) == "image" } {
         if 0 {
-            set f [open "last.ppm" "w"]
-            fconfigure $f -encoding binary
-            puts -nonewline $f $bytes
+            set f [open "last.ppm" "w"] 
+            puts $f $bytes
             close $f
         }
@@ -930,6 +928,6 @@
 	$_arcball resize $w $h
 	DoResize
-	if { $_settings(-stretchtofit) } {
-	    AdjustSetting -stretchtofit
+	if { $_settings(stretchToFit) } {
+	    AdjustSetting stretchToFit
 	}
     }
@@ -938,21 +936,15 @@
 	# Reset the camera and other view parameters
 	#
-        InitSettings -isheightmap -background
-
-        # Setting a custom exponent and label format for axes is causing
-        # a problem with rounding.  Near zero ticks aren't rounded by 
-        # the %g format.  The VTK CubeAxes seem to currently work best
-        # when allowed to automatically set the exponent and precision 
-        # based on the axis ranges.  This does tend to result in less 
-        # visual clutter, so I think it is best to use the automatic 
-        # settings by default.  We can test more fine-grained
-        # controls on the axis settings tab if necessary.
-        # -Leif
-        #SendCmd "axis exp 0 0 0 1"
+        InitSettings isHeightmap background
+
+        # Let's see how this goes.  I think it's preferable to overloading the
+        # axis title with the exponent.
+        SendCmd "axis exp 0 0 0 1"
 
 	SendCmd "axis lrot z 90"
-	$_arcball quaternion [ViewToQuaternion]
-        if {$_settings(-isheightmap) } {
-            if { $_view(-ortho)} {
+	set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+	$_arcball quaternion $q 
+        if {$_settings(isHeightmap) } {
+            if { $_view(ortho)} {
                 SendCmd "camera mode ortho"
             } else {
@@ -983,6 +975,5 @@
 		if 0 { 
                     set f [open /tmp/vtkheightmap.vtk "w"]
-                    fconfigure $f -translation binary -encoding binary
-                    puts -nonewline $f $bytes
+                    puts $f $bytes
                     close $f
 		}
@@ -998,5 +989,5 @@
                     lappend info "dataset_size"  $length
                     lappend info "dataset_tag"   $tag
-                    SendCmd "clientinfo [list $info]"
+                    SendCmd [list "clientinfo" $info]
                 }
                 SendCmd "dataset add $tag data follows $length"
@@ -1047,9 +1038,11 @@
         $itk_component(field) value $_curFldLabel
     }
-    InitSettings -stretchtofit -outline
+    InitSettings stretchToFit outline
 
     if { $_reset } {
 	SendCmd "axis tickpos outside"
-        #SendCmd "axis lformat all %g"
+	foreach axis { x y z } {
+	    SendCmd "axis lformat $axis %g"
+	}
         
 	foreach axis { x y z } {
@@ -1074,7 +1067,5 @@
 
 	    if {$axis == "z" && [$_first hints ${axis}units] == ""} {
-                if {$_curFldName != ""} {
-                    set units [lindex $_fields($_curFldName) 1]
-                }
+		set units [lindex $_fields($_curFldName) 1]
 	    } else {
 		set units [$_first hints ${axis}units]
@@ -1089,7 +1080,8 @@
 	#
 	ResetAxes
-	$_arcball quaternion [ViewToQuaternion]
-        if {$_settings(-isheightmap) } {
-            if { $_view(-ortho)} {
+	set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+	$_arcball quaternion $q 
+        if {$_settings(isHeightmap) } {
+            if { $_view(ortho)} {
                 SendCmd "camera mode ortho"
             } else {
@@ -1100,9 +1092,9 @@
         }
 	PanCamera
-	InitSettings -xgrid -ygrid -zgrid \
-	    -axisvisible -axislabels -heightmapscale -field -isheightmap \
-            -numisolines
+	InitSettings axisXGrid axisYGrid axisZGrid \
+	    axisVisible axisLabels heightmapScale field isHeightmap \
+            numIsolines
         if { [array size _fields] < 2 } {
-            catch {blt::table forget $itk_component(field) $itk_component(field_l)}
+            blt::table forget $itk_component(field) $itk_component(field_l)
         }
         RequestLegend
@@ -1166,11 +1158,11 @@
 itcl::body Rappture::VtkHeightmapViewer::CameraReset {} {
     array set _view {
-        -qw      0.36
-        -qx      0.25
-        -qy      0.50
-        -qz      0.70
-        -xpan    0
-        -ypan    0
-        -zoom    1.0
+        qw      0.36
+        qx      0.25
+        qy      0.50
+        qz      0.70
+        zoom    1.0
+        xpan    0
+        ypan    0 
     }
     if { $_first != "" } {
@@ -1180,6 +1172,7 @@
         }
     }
-    $_arcball quaternion [ViewToQuaternion]
-    if {$_settings(-isheightmap) } {
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    $_arcball quaternion $q
+    if {$_settings(isHeightmap) } {
         DoRotate
     }
@@ -1198,16 +1191,16 @@
     switch -- $option {
         "in" {
-            set _view(-zoom) [expr {$_view(-zoom)*1.25}]
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*1.25}]
+            SendCmd "camera zoom $_view(zoom)"
         }
         "out" {
-            set _view(-zoom) [expr {$_view(-zoom)*0.8}]
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*0.8}]
+            SendCmd "camera zoom $_view(zoom)"
         }
         "reset" {
             array set _view {
-                -xpan    0
-                -ypan    0
-                -zoom    1.0
+                zoom    1.0
+                xpan    0
+                ypan    0 
             }
             SendCmd "camera reset"
@@ -1217,6 +1210,6 @@
 
 itcl::body Rappture::VtkHeightmapViewer::PanCamera {} {
-    set x $_view(-xpan)
-    set y $_view(-ypan)
+    set x $_view(xpan)
+    set y $_view(ypan)
     SendCmd "camera pan $x $y"
 }
@@ -1296,6 +1289,6 @@
             set x [expr $x / double($w)]
             set y [expr $y / double($h)]
-            set _view(-xpan) [expr $_view(-xpan) + $x]
-            set _view(-ypan) [expr $_view(-ypan) + $y]
+            set _view(xpan) [expr $_view(xpan) + $x]
+            set _view(ypan) [expr $_view(ypan) + $y]
             PanCamera
             return
@@ -1319,6 +1312,6 @@
             set _click(x) $x
             set _click(y) $y
-            set _view(-xpan) [expr $_view(-xpan) - $dx]
-            set _view(-ypan) [expr $_view(-ypan) - $dy]
+            set _view(xpan) [expr $_view(xpan) - $dx]
+            set _view(ypan) [expr $_view(ypan) - $dy]
             PanCamera
         }
@@ -1342,7 +1335,7 @@
 itcl::body Rappture::VtkHeightmapViewer::InitSettings { args } {
     foreach spec $args {
-        if { [info exists _settings($_first${spec})] } {
+        if { [info exists _settings($_first-$spec)] } {
             # Reset global setting with dataobj specific setting
-            set _settings($spec) $_settings($_first${spec})
+            set _settings($spec) $_settings($_first-$spec)
         }
         AdjustSetting $spec
@@ -1362,5 +1355,5 @@
     }
     switch -- $what {
-        "-axisflymode" {
+        "axisFlymode" {
             set mode [$itk_component(axisflymode) value]
             set mode [$itk_component(axisflymode) translate $mode]
@@ -1368,17 +1361,24 @@
             SendCmd "axis flymode $mode"
         }
-        "-axislabels" {
+        "axisLabels" {
+            set bool $_settings(axisLabels)
+            SendCmd "axis labels all $bool"
+        }
+        "axisMinorTicks" {
+            set bool $_settings(axisMinorTicks)
+	    foreach axis { x y z } { 
+		SendCmd "axis minticks ${axis} $bool"
+	    }
+        }
+        "axisVisible" {
+            set bool $_settings(axisVisible)
+            SendCmd "axis visible all $bool"
+        }
+        "axisXGrid" - "axisYGrid" - "axisZGrid" {
+            set axis [string tolower [string range $what 4 4]]
             set bool $_settings($what)
-            SendCmd "axis labels all $bool"
-        }
-        "-axisminorticks" {
-            set bool $_settings($what)
-            SendCmd "axis minticks all $bool"
-        }
-        "-axisvisible" {
-            set bool $_settings($what)
-            SendCmd "axis visible all $bool"
-        }
-        "-background" {
+            SendCmd "axis grid $axis $bool"
+        }
+        "background" {
             set bg [$itk_component(background) value]
 	    array set fgcolors {
@@ -1395,22 +1395,22 @@
 	    DrawLegend
         }
-        "-colormap" {
-            set _changed($what) 1
+        "colormap" {
+            set _changed(colormap) 1
             StartBufferingCommands
             set color [$itk_component(colormap) value]
-            set _settings($what) $color
+            set _settings(colormap) $color
 	    if { $color == "none" } {
-		if { $_settings(-colormapvisible) } {
+		if { $_settings(colormapVisible) } {
 		    SendCmd "heightmap surface 0"
-		    set _settings(-colormapvisible) 0
+		    set _settings(colormapVisible) 0
 		}
 	    } else {
-		if { !$_settings(-colormapvisible) } {
+		if { !$_settings(colormapVisible) } {
 		    SendCmd "heightmap surface 1"
-		    set _settings(-colormapvisible) 1
+		    set _settings(colormapVisible) 1
 		}
 		SetCurrentColormap $color
-                if {$_settings(-colormapdiscrete)} {
-                    set numColors [expr $_settings(-numisolines) + 1]
+                if {$_settings(colormapDiscrete)} {
+                    set numColors [expr $_settings(numIsolines) + 1]
                     SendCmd "colormap res $numColors $color"
                 }
@@ -1419,11 +1419,11 @@
 	    EventuallyRequestLegend
         }
-        "-colormapvisible" {
+        "colormapVisible" {
             set bool $_settings($what)
             SendCmd "heightmap surface $bool"
         }
-        "-colormapdiscrete" {
+        "colormapDiscrete" {
             set bool $_settings($what)
-            set numColors [expr $_settings(-numisolines) + 1]
+            set numColors [expr $_settings(numIsolines) + 1]
             StartBufferingCommands
             if {$bool} {
@@ -1439,12 +1439,12 @@
             EventuallyRequestLegend
         }
-        "-edges" {
-            set bool $_settings($what)
+        "edges" {
+            set bool $_settings(edges)
             SendCmd "heightmap edges $bool"
         }
-        "-field" {
+        "field" {
             set label [$itk_component(field) value]
             set fname [$itk_component(field) translate $label]
-            set _settings($what) $fname
+            set _settings(field) $fname
             if { [info exists _fields($fname)] } {
                 foreach { label units components } $_fields($fname) break
@@ -1488,6 +1488,6 @@
             DrawLegend
         }
-        "-heightmapscale" {
-	    if { $_settings(-isheightmap) } {
+        "heightmapScale" {
+	    if { $_settings(isHeightmap) } {
 		set scale [GetHeightmapScale]
                 # Have to set the datasets individually because we are 
@@ -1500,21 +1500,23 @@
 	    }
         }
-        "-isheightmap" {
-	    set bool $_settings($what)
+        "isHeightmap" {
+	    set bool $_settings(isHeightmap)
             set c $itk_component(view)
             StartBufferingCommands
             # Fix heightmap scale: 0 for contours, 1 for heightmaps.
             if { $bool } {
-                set _settings(-heightmapscale) 50
-                set _settings(-opacity) $_settings(-saveopacity)
-                set _settings(-lighting) $_settings(-savelighting)
-                set _settings(-outline) 0
+                set _settings(heightmapScale) 50
+                set _settings(opacity) $_settings(saveOpacity)
+                set _settings(lighting) $_settings(saveLighting)
+                set _settings(outline) 0
             } else {
-                set _settings(-heightmapscale) 0
-                set _settings(-lighting) 0
-                set _settings(-opacity) 100
-                set _settings(-outline)  $_settings(-saveoutline)
-            }
-            InitSettings -lighting -opacity -outline
+                set _settings(heightmapScale) 0
+                set _settings(lighting) 0
+                set _settings(opacity) 100
+                set _settings(outline)  $_settings(saveOutline)
+            }
+            AdjustSetting lighting
+            AdjustSetting opacity
+            AdjustSetting outline
             set scale [GetHeightmapScale]
             # Have to set the datasets individually because we are 
@@ -1531,5 +1533,5 @@
 		$itk_component(scale_l) configure -state normal
 		$itk_component(outline) configure -state disabled
-                if {$_view(-ortho)} {
+                if {$_view(ortho)} {
                     SendCmd "camera mode ortho"
                 } else {
@@ -1545,5 +1547,5 @@
                 SendCmd "camera mode image"
             }
-            if {$_settings(-stretchtofit)} {
+            if {$_settings(stretchToFit)} {
                 if {$scale == 0} {
                     SendCmd "camera aspect window"
@@ -1554,5 +1556,5 @@
             ResetAxes
             if { $bool } {
-                set q [ViewToQuaternion]
+                set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
                 $_arcball quaternion $q
                 SendCmd "camera orient $q" 
@@ -1576,15 +1578,15 @@
             StopBufferingCommands
         }
-        "-isolinecolor" {
+        "isolineColor" {
             set color [$itk_component(isolinecolor) value]
 	    if { $color == "none" } {
-		if { $_settings(-isolinesvisible) } {
+		if { $_settings(isolinesVisible) } {
 		    SendCmd "heightmap isolines 0"
-		    set _settings(-isolinesvisible) 0
+		    set _settings(isolinesVisible) 0
 		}
 	    } else {
-		if { !$_settings(-isolinesvisible) } {
+		if { !$_settings(isolinesVisible) } {
 		    SendCmd "heightmap isolines 1"
-		    set _settings(-isolinesvisible) 1
+		    set _settings(isolinesVisible) 1
 		}
 		SendCmd "heightmap isolinecolor [Color2RGB $color]"
@@ -1592,10 +1594,10 @@
 	    DrawLegend
         }
-        "-isolinesvisible" {
+        "isolinesVisible" {
 	    set bool $_settings($what)
             SendCmd "heightmap isolines $bool"
 	    DrawLegend
         }
-        "-legendvisible" {
+        "legendVisible" {
             if { !$_settings($what) } {
 		$itk_component(view) delete legend
@@ -1603,7 +1605,7 @@
 	    DrawLegend
         }
-        "-lighting" {
-	    if { $_settings(-isheightmap) } {
-                set _settings(-savelighting) $_settings($what)
+        "lighting" {
+	    if { $_settings(isHeightmap) } {
+                set _settings(saveLighting) $_settings(lighting)
 		set bool $_settings($what)
 		SendCmd "heightmap lighting $bool"
@@ -1612,12 +1614,12 @@
 	    }
         }
-        "-numisolines" {
-            set _settings($what) [$itk_component(numisolines) value]
-            set _currentNumIsolines $_settings($what)
+        "numIsolines" {
+            set _settings(numIsolines) [$itk_component(numisolines) value]
+            set _currentNumIsolines $_settings(numIsolines)
             UpdateContourList
-            set _changed($what) 1
+            set _changed(numIsolines) 1
             SendCmd "heightmap contourlist [list $_contourList]"
-            if {$_settings(-colormapdiscrete)} {
-                set numColors [expr $_settings($what) + 1]
+            if {$_settings(colormapDiscrete)} {
+                set numColors [expr $_settings(numIsolines) + 1]
                 SendCmd "colormap res $numColors"
                 EventuallyRequestLegend
@@ -1626,24 +1628,25 @@
             }
         }
-        "-opacity" {
-            set _changed($what) 1
-            set val [expr $_settings($what) * 0.01]
-	    if { $_settings(-isheightmap) } {
-                set _settings(-saveopacity) $_settings($what)
-                SendCmd "heightmap opacity $val"
+        "opacity" {
+            set _changed(opacity) 1
+	    if { $_settings(isHeightmap) } {
+                set _settings(saveOpacity) $_settings(opacity)
+                set val $_settings(opacity)
+                set sval [expr { 0.01 * double($val) }]
+                SendCmd "heightmap opacity $sval"
             } else {
-		SendCmd "heightmap opacity 1.0"
-            }
-        }
-        "-outline" {
-	    if { $_settings(-isheightmap) } {
+		SendCmd "heightmap opacity 1"
+            }
+        }
+        "outline" {
+	    if { $_settings(isHeightmap) } {
 		SendCmd "outline visible 0"
             } else {
-                set _settings(-saveoutline) $_settings($what)
-                set bool $_settings($what)
+                set _settings(saveOutline) $_settings(outline)
+                set bool $_settings(outline)
                 SendCmd "outline visible $bool"
             }
 	}
-        "-stretchtofit" {
+        "stretchToFit" {
 	    set bool $_settings($what)
 	    if { $bool } {
@@ -1659,12 +1662,7 @@
             Zoom reset
 	}
-        "-wireframe" {
+        "wireframe" {
             set bool $_settings($what)
             SendCmd "heightmap wireframe $bool"
-        }
-        "-xgrid" - "-ygrid" - "-zgrid" {
-            set axis [string tolower [string range $what 1 1]]
-            set bool $_settings($what)
-            SendCmd "axis grid $axis $bool"
         }
 	default {
@@ -1719,6 +1717,5 @@
     if { $_currentColormap != ""  } {
 	set cmap $_currentColormap
-	#SendCmd "legend $cmap scalar $_curFldName {} $w $h 0"
-        SendCmd "legend2 $cmap $w $h"
+	SendCmd "legend $cmap scalar $_curFldName {} $w $h 0"
     }
 }
@@ -1780,4 +1777,5 @@
 }
 
+
 #
 # BuildColormap --
@@ -1800,8 +1798,8 @@
     switch -- $itk_option(-mode) {
 	"heightmap" {
-	    set _settings(-isheightmap) 1
+	    set _settings(isHeightmap) 1
 	}
 	"contour" {
-	    set _settings(-isheightmap) 0
+	    set _settings(isHeightmap) 0
 	} 
 	default {
@@ -1810,5 +1808,5 @@
     }
     if { !$_reset } {
-        AdjustSetting -isheightmap
+        AdjustSetting isHeightmap
     }
 }
@@ -1834,8 +1832,18 @@
         set rgb [Color2RGB $itk_option(-plotforeground)]
         if { !$_reset } {
+            SendCmd "outline color $rgb"
             SendCmd "axis color all $rgb"
-            SendCmd "outline color $rgb"
-        }
-    }
+        }
+    }
+}
+
+itcl::body Rappture::VtkHeightmapViewer::limits3 { dataobj } {
+    lappend limits x [$dataobj limits x]
+    lappend limits y [$dataobj limits y] 
+    if { [catch { $dataobj limits $_curFldName } vlim] != 0 } {
+        set vlim [$dataobj limits v] 
+    }
+    lappend limits v $vlim
+    return $limits
 }
 
@@ -1852,12 +1860,12 @@
     checkbutton $inner.legend \
         -text "Legend" \
-        -variable [itcl::scope _settings(-legendvisible)] \
-        -command [itcl::code $this AdjustSetting -legendvisible] \
+        -variable [itcl::scope _settings(legendVisible)] \
+        -command [itcl::code $this AdjustSetting legendVisible] \
         -font "Arial 9"
 
     checkbutton $inner.wireframe \
         -text "Wireframe" \
-        -variable [itcl::scope _settings(-wireframe)] \
-        -command [itcl::code $this AdjustSetting -wireframe] \
+        -variable [itcl::scope _settings(wireframe)] \
+        -command [itcl::code $this AdjustSetting wireframe] \
         -font "Arial 9"
 
@@ -1865,6 +1873,6 @@
 	checkbutton $inner.lighting \
 	    -text "Enable Lighting" \
-	    -variable [itcl::scope _settings(-lighting)] \
-	    -command [itcl::code $this AdjustSetting -lighting] \
+	    -variable [itcl::scope _settings(lighting)] \
+	    -command [itcl::code $this AdjustSetting lighting] \
 	    -font "Arial 9"
     } {
@@ -1873,6 +1881,6 @@
     checkbutton $inner.edges \
         -text "Edges" \
-        -variable [itcl::scope _settings(-edges)] \
-        -command [itcl::code $this AdjustSetting -edges] \
+        -variable [itcl::scope _settings(edges)] \
+        -command [itcl::code $this AdjustSetting edges] \
         -font "Arial 9"
 
@@ -1880,6 +1888,6 @@
         checkbutton $inner.outline \
             -text "Outline" \
-            -variable [itcl::scope _settings(-outline)] \
-            -command [itcl::code $this AdjustSetting -outline] \
+            -variable [itcl::scope _settings(outline)] \
+            -command [itcl::code $this AdjustSetting outline] \
             -font "Arial 9"
     } {
@@ -1888,18 +1896,18 @@
     checkbutton $inner.stretch \
         -text "Stretch to fit" \
-        -variable [itcl::scope _settings(-stretchtofit)] \
-        -command [itcl::code $this AdjustSetting -stretchtofit] \
+        -variable [itcl::scope _settings(stretchToFit)] \
+        -command [itcl::code $this AdjustSetting stretchToFit] \
         -font "Arial 9"
 
     checkbutton $inner.isolines \
         -text "Isolines" \
-        -variable [itcl::scope _settings(-isolinesvisible)] \
-        -command [itcl::code $this AdjustSetting -isolinesvisible] \
+        -variable [itcl::scope _settings(isolinesVisible)] \
+        -command [itcl::code $this AdjustSetting isolinesVisible] \
         -font "Arial 9"
 
     checkbutton $inner.colormapDiscrete \
         -text "Discrete Colormap" \
-        -variable [itcl::scope _settings(-colormapdiscrete)] \
-        -command [itcl::code $this AdjustSetting -colormapdiscrete] \
+        -variable [itcl::scope _settings(colormapDiscrete)] \
+        -command [itcl::code $this AdjustSetting colormapDiscrete] \
         -font "Arial 9"
 
@@ -1913,5 +1921,5 @@
     }
     bind $inner.field <<Value>> \
-        [itcl::code $this AdjustSetting -field]
+        [itcl::code $this AdjustSetting field]
 
     label $inner.colormap_l -text "Colormap" -font "Arial 9" 
@@ -1919,8 +1927,26 @@
         Rappture::Combobox $inner.colormap -width 10 -editable no
     }
-    $inner.colormap choices insert end [GetColormapList -includeNone]
-    $itk_component(colormap) value $_settings(-colormap)
+    $inner.colormap choices insert end \
+        "BCGYR"              "BCGYR"            \
+        "BGYOR"              "BGYOR"            \
+        "blue"               "blue"             \
+        "blue-to-brown"      "blue-to-brown"    \
+        "blue-to-orange"     "blue-to-orange"   \
+        "blue-to-grey"       "blue-to-grey"     \
+        "green-to-magenta"   "green-to-magenta" \
+        "greyscale"          "greyscale"        \
+        "nanohub"            "nanohub"          \
+        "rainbow"            "rainbow"          \
+        "spectral"           "spectral"         \
+        "ROYGB"              "ROYGB"            \
+        "RYGCB"              "RYGCB"            \
+        "brown-to-blue"      "brown-to-blue"    \
+        "grey-to-blue"       "grey-to-blue"     \
+        "orange-to-blue"     "orange-to-blue"   \
+	"none"		     "none"
+
+    $itk_component(colormap) value "BCGYR"
     bind $inner.colormap <<Value>> \
-        [itcl::code $this AdjustSetting -colormap]
+        [itcl::code $this AdjustSetting colormap]
 
     label $inner.isolinecolor_l -text "Isolines Color" -font "Arial 9" 
@@ -1940,7 +1966,7 @@
 	"none"		     "none"
 
-    $itk_component(isolinecolor) value $_settings(-isolinecolor)
+    $itk_component(isolinecolor) value "black"
     bind $inner.isolinecolor <<Value>> \
-	[itcl::code $this AdjustSetting -isolinecolor]
+	[itcl::code $this AdjustSetting isolineColor]
 
     label $inner.background_l -text "Background Color" -font "Arial 9" 
@@ -1954,6 +1980,5 @@
 
     $itk_component(background) value "white"
-    bind $inner.background <<Value>> \
-        [itcl::code $this AdjustSetting -background]
+    bind $inner.background <<Value>> [itcl::code $this AdjustSetting background]
 
     itk_component add opacity_l {
